<?php
/**
* MailChimp List Snippet
* Author: Garry Nutting
* Date: 11/09/08
*
* Outputs a list of MailChimp lists and their IDs - should be used temporarily to find list IDs
*/

$debug = isset($debug) ? $debug : false;
$debugOutput = '';
$output = '';
require_once MODX_BASE_PATH.'assets/snippets/mailchimp/classes/MCAPI.class.php';
require_once MODX_BASE_PATH.'assets/snippets/mailchimp/includes/config.inc.php';
		
// Connect to the MailChimp server with the user's credentials.
$api = new MCAPI($username, $password);
if ($api->errorCode!='') {
	if ($debug == true) {
		$debugOutput .= "code:".$api->errorCode."\n";
		$debugOutput .= "msg :".$api->errorMessage."\n";
	} else {
		return;
	}
}

$retVal = $api->lists();
		
if (!$retVal) {
	if ($debug == true) {
		$debugOutput .= "Unable to load lists()!\n";
		$debugOutput .= "\tCode=".$api->errorCode."\n";
		$debugOutput .= "\tMsg=".$api->errorMessage."\n";
	}
} else {
	if ($debug == true) {
		$debugOutput .= "Returned: ".$retVal."\n";
	}
	$output .='Your Lists (ID => Name):<br /><ul>';
	foreach ($retVal as $list) {
		$output .= '<li>'.$list['id'].' => '.$list['name'].'</li>';
	}
	$output .= '</ul>';
}

if ($debug == true) echo $debugOutput;
return $output;
?>